Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkCellLocator Class Reference

`#include <vtkCellLocator.h>`

Inheritance diagram for vtkCellLocator:

[legend]
Collaboration diagram for vtkCellLocator:

[legend]
List of all members.

## Detailed Description

octree-based spatial search object to quickly locate cells

Date:
  2002/06/08 00:28:44

Revision:
  1.58

vtkCellLocator is a spatial search object to quickly locate cells in 3D. vtkCellLocator uses a uniform-level octree subdivision, where each octant (an octant is also referred to as a bucket) carries an indication of whether it is empty or not, and each leaf octant carries a list of the cells inside of it. (An octant is not empty if it has one or more cells inside of it.) Typical operations are intersection with a line to return candidate cells, or intersection with another vtkCellLocator to return candidate cells.

Warning:
  Many other types of spatial locators have been developed, such as variable depth octrees and kd-trees. These are often more efficient for the operations described here. vtkCellLocator has been designed for subclassing; so these locators can be derived if necessary.

See also:
  vtkLocator vtkPointLocator vtkOBBTree

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (31%)
  - Miller, Jim (29%)
  - Blue, Rusty (27%)
  - Martin, Ken (6%)

CVS logs (CVSweb):
  - .`cxx` (`/Filtering/vtkCellLocator.cxx)`
  - .`h` (`/Filtering/vtkCellLocator.h)`

Tests:
  vtkCellLocator (Tests)

Definition at line 68 of file vtkCellLocator.h.

## Public Types
typedef vtkLocator | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
virtual vtkIdList * | GetCells (int bucket)
virtual int | GetNumberOfBuckets (void)
virtual void | SetNumberOfCellsPerBucket (int)
virtual int | GetNumberOfCellsPerBucket ()
virtual void | SetCacheCellBounds (int)
virtual int | GetCacheCellBounds ()
virtual void | CacheCellBoundsOn ()
virtual void | CacheCellBoundsOff ()
virtual int | IntersectWithLine (float a0[3], float a1[3], float tol, float &t, float x[3], float pcoords[3], int &subId)
virtual int | IntersectWithLine (float a0[3], float a1[3], float tol, float &t, float x[3], float pcoords[3], int &subId, vtkIdType &cellId)
virtual int | IntersectWithLine (float a0[3], float a1[3], float tol, float &t, float x[3], float pcoords[3], int &subId, vtkIdType &cellId, vtkGenericCell *cell)
void | FindClosestPoint (float x[3], float closestPoint[3], vtkIdType &cellId, int &subId, float &dist2)
void | FindClosestPoint (float x[3], float closestPoint[3], vtkGenericCell *cell, vtkIdType &cellId, int &subId, float &dist2)
int | FindClosestPointWithinRadius (float x[3], float radius, float closestPoint[3], vtkIdType &cellId, int &subId, float &dist2)
int | FindClosestPointWithinRadius (float x[3], float radius, float closestPoint[3], vtkGenericCell *cell, vtkIdType &cellId, int &subId, float &dist2)
int | FindClosestPointWithinRadius (float x[3], float radius, float closestPoint[3], vtkGenericCell *cell, vtkIdType &cellId, int &subId, float &dist2, int &inside)
void | FreeSearchStructure ()
void | BuildLocator ()
void | GenerateRepresentation (int level, vtkPolyData *pd)
## Static Public Methods
int | IsTypeOf (const char *type)
vtkCellLocator * | SafeDownCast (vtkObject *o)
vtkCellLocator * | New ()
## Protected Methods
| vtkCellLocator ()
| ~vtkCellLocator ()
void | GetBucketNeighbors (int ijk[3], int ndivs, int level)
void | GetOverlappingBuckets (float x[3], int ijk[3], float dist, int prevMinLevel[3], int prevMaxLevel[3])
void | ClearCellHasBeenVisited ()
void | ClearCellHasBeenVisited (int id)
float | Distance2ToBucket (float x[3], int nei[3])
float | Distance2ToBounds (float x[3], float bounds[6])
void | MarkParents (void *, int, int, int, int, int)
void | GetChildren (int idx, int level, int children[8])
int | GenerateIndex (int offset, int numDivs, int i, int j, int k, vtkIdType &idx)
void | GenerateFace (int face, int numDivs, int i, int j, int k, vtkPoints *pts, vtkCellArray *polys)
## Protected Attributes
int | NumberOfCellsPerBucket
int | NumberOfOctants
float | Bounds [6]
int | NumberOfParents
float | H [3]
int | NumberOfDivisions
vtkIdList ** | Tree
vtkNeighborCells * | Buckets
unsigned char * | CellHasBeenVisited
unsigned char | QueryNumber
int | CacheCellBounds
float(* | CellBounds )[6]

## Member Typedef Documentation

typedef vtkLocator vtkCellLocator::Superclass

| Reimplemented from vtkLocator. Reimplemented in vtkOBBTree. Definition at line 71 of file vtkCellLocator.h.

## Constructor & Destructor Documentation

vtkCellLocator::vtkCellLocator | ( |  | ) | `[protected]`

vtkCellLocator::~vtkCellLocator | ( |  | ) | `[protected]`

## Member Function Documentation

virtual const char* vtkCellLocator::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkLocator. Reimplemented in vtkOBBTree.

int vtkCellLocator::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkLocator. Reimplemented in vtkOBBTree.

virtual int vtkCellLocator::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkLocator. Reimplemented in vtkOBBTree.

vtkCellLocator* vtkCellLocator::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkLocator. Reimplemented in vtkOBBTree.

void vtkCellLocator::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkLocator.

vtkCellLocator* vtkCellLocator::New | ( |  | ) | `[static]`

| Construct with automatic computation of divisions, averaging 25 cells per bucket. Reimplemented from vtkObject. Reimplemented in vtkOBBTree.

virtual void vtkCellLocator::SetNumberOfCellsPerBucket | ( | int |  | ) | `[virtual]`

| Specify the average number of cells in each octant.

virtual int vtkCellLocator::GetNumberOfCellsPerBucket | ( |  | ) | `[virtual]`

| Specify the average number of cells in each octant.

virtual void vtkCellLocator::SetCacheCellBounds | ( | int |  | ) | `[virtual]`

| Boolean controls whether the bounds of each cell are computed only once and then saved. Should be 10 to 20% faster if repeatedly calling any of the FindClosestPoint routines and the extra memory won't cause disk caching (24 extra bytes per cell are required to save the bounds).

virtual int vtkCellLocator::GetCacheCellBounds | ( |  | ) | `[virtual]`

| Boolean controls whether the bounds of each cell are computed only once and then saved. Should be 10 to 20% faster if repeatedly calling any of the FindClosestPoint routines and the extra memory won't cause disk caching (24 extra bytes per cell are required to save the bounds).

virtual void vtkCellLocator::CacheCellBoundsOn | ( |  | ) | `[virtual]`

| Boolean controls whether the bounds of each cell are computed only once and then saved. Should be 10 to 20% faster if repeatedly calling any of the FindClosestPoint routines and the extra memory won't cause disk caching (24 extra bytes per cell are required to save the bounds).

virtual void vtkCellLocator::CacheCellBoundsOff | ( |  | ) | `[virtual]`

| Boolean controls whether the bounds of each cell are computed only once and then saved. Should be 10 to 20% faster if repeatedly calling any of the FindClosestPoint routines and the extra memory won't cause disk caching (24 extra bytes per cell are required to save the bounds).

virtual int vtkCellLocator::IntersectWithLine | ( | float | a0[3],
|  | float | a1[3],
|  | float | tol,
|  | float & | t,
|  | float | x[3],
|  | float | pcoords[3],
|  | int & | subId
| ) | `[virtual]`

| Return intersection point (if any) of finite line with cells contained in cell locator. Reimplemented in vtkOBBTree.

virtual int vtkCellLocator::IntersectWithLine | ( | float | a0[3],
|  | float | a1[3],
|  | float | tol,
|  | float & | t,
|  | float | x[3],
|  | float | pcoords[3],
|  | int & | subId,
|  | vtkIdType & | cellId
| ) | `[virtual]`

| Return intersection point (if any) AND the cell which was intersected by the finite line. Reimplemented in vtkOBBTree.

virtual int vtkCellLocator::IntersectWithLine | ( | float | a0[3],
|  | float | a1[3],
|  | float | tol,
|  | float & | t,
|  | float | x[3],
|  | float | pcoords[3],
|  | int & | subId,
|  | vtkIdType & | cellId,
|  | vtkGenericCell * | cell
| ) | `[virtual]`

| Return intersection point (if any) AND the cell which was intersected by the finite line. The cell is returned as a cell id and as a generic cell. Reimplemented in vtkOBBTree.

void vtkCellLocator::FindClosestPoint | ( | float | x[3],
|  | float | closestPoint[3],
|  | vtkIdType & | cellId,
|  | int & | subId,
|  | float & | dist2
| ) |

| Return the closest point and the cell which is closest to the point x. The closest point is somewhere on a cell, it need not be one of the vertices of the cell.

void vtkCellLocator::FindClosestPoint | ( | float | x[3],
|  | float | closestPoint[3],
|  | vtkGenericCell * | cell,
|  | vtkIdType & | cellId,
|  | int & | subId,
|  | float & | dist2
| ) |

| Return the closest point and the cell which is closest to the point x. The closest point is somewhere on a cell, it need not be one of the vertices of the cell. This version takes in a vtkGenericCell to avoid allocating and deallocating the cell. This is much faster than the version which does not take a *cell, especially when this function is called many times in a row such as by a for loop, where the allocation and deallocation can be done only once outside the for loop. If a cell is found, "cell" contains the points and ptIds for the cell "cellId" upon exit.

int vtkCellLocator::FindClosestPointWithinRadius | ( | float | x[3],
|  | float | radius,
|  | float | closestPoint[3],
|  | vtkIdType & | cellId,
|  | int & | subId,
|  | float & | dist2
| ) |

| Return the closest point within a specified radius and the cell which is closest to the point x. The closest point is somewhere on a cell, it need not be one of the vertices of the cell. This method returns 1 if a point is found within the specified radius. If there are no cells within the specified radius, the method returns 0 and the values of closestPoint, cellId, subId, and dist2 are undefined.

int vtkCellLocator::FindClosestPointWithinRadius | ( | float | x[3],
|  | float | radius,
|  | float | closestPoint[3],
|  | vtkGenericCell * | cell,
|  | vtkIdType & | cellId,
|  | int & | subId,
|  | float & | dist2
| ) |

| Return the closest point within a specified radius and the cell which is closest to the point x. The closest point is somewhere on a cell, it need not be one of the vertices of the cell. This method returns 1 if a point is found within the specified radius. If there are no cells within the specified radius, the method returns 0 and the values of closestPoint, cellId, subId, and dist2 are undefined. This version takes in a vtkGenericCell to avoid allocating and deallocating the cell. This is much faster than the version which does not take a *cell, especially when this function is called many times in a row such as by a for loop, where the allocation and deallocation can be done only once outside the for loop. If a closest point is found, "cell" contains the points and ptIds for the cell "cellId" upon exit.

int vtkCellLocator::FindClosestPointWithinRadius | ( | float | x[3],
|  | float | radius,
|  | float | closestPoint[3],
|  | vtkGenericCell * | cell,
|  | vtkIdType & | cellId,
|  | int & | subId,
|  | float & | dist2,
|  | int & | inside
| ) |

| Return the closest point within a specified radius and the cell which is closest to the point x. The closest point is somewhere on a cell, it need not be one of the vertices of the cell. This method returns 1 if a point is found within the specified radius. If there are no cells within the specified radius, the method returns 0 and the values of closestPoint, cellId, subId, and dist2 are undefined. This version takes in a vtkGenericCell to avoid allocating and deallocating the cell. This is much faster than the version which does not take a *cell, especially when this function is called many times in a row such as by a for loop, where the allocation and dealloction can be done only once outside the for loop. If a closest point is found, "cell" contains the points and ptIds for the cell "cellId" upon exit. If a closest point is found, inside returns the return value of the EvaluatePosition call to the closest cell; inside(=1) or outside(=0).

virtual vtkIdList* vtkCellLocator::GetCells | ( | int | bucket | ) | `[virtual]`

| Get the cells in a particular bucket.

virtual int vtkCellLocator::GetNumberOfBuckets | ( | void |  | ) | `[virtual]`

| Return number of buckets available. Insure that the locator has been built before attempting to access buckets (octants).

void vtkCellLocator::FreeSearchStructure | ( |  | ) | `[virtual]`

| Satisfy vtkLocator abstract interface. Implements vtkLocator. Reimplemented in vtkOBBTree.

void vtkCellLocator::BuildLocator | ( |  | ) | `[virtual]`

| Satisfy vtkLocator abstract interface. Implements vtkLocator. Reimplemented in vtkOBBTree.

void vtkCellLocator::GenerateRepresentation | ( | int | level,
|  | vtkPolyData * | pd
| ) | `[virtual]`

| Satisfy vtkLocator abstract interface. Implements vtkLocator. Reimplemented in vtkOBBTree.

void vtkCellLocator::GetBucketNeighbors | ( | int | ijk[3],
|  | int | ndivs,
|  | int | level
| ) | `[protected]`

void vtkCellLocator::GetOverlappingBuckets | ( | float | x[3],
|  | int | ijk[3],
|  | float | dist,
|  | int | prevMinLevel[3],
|  | int | prevMaxLevel[3]
| ) | `[protected]`

void vtkCellLocator::ClearCellHasBeenVisited | ( |  | ) | `[protected]`

void vtkCellLocator::ClearCellHasBeenVisited | ( | int | id | ) | `[protected]`

float vtkCellLocator::Distance2ToBucket | ( | float | x[3],
|  | int | nei[3]
| ) | `[protected]`

float vtkCellLocator::Distance2ToBounds | ( | float | x[3],
|  | float | bounds[6]
| ) | `[protected]`

void vtkCellLocator::MarkParents | ( | void * | ,
|  | int | ,
|  | int | ,
|  | int | ,
|  | int | ,
|  | int |
| ) | `[protected]`

void vtkCellLocator::GetChildren | ( | int | idx,
|  | int | level,
|  | int | children[8]
| ) | `[protected]`

int vtkCellLocator::GenerateIndex | ( | int | offset,
|  | int | numDivs,
|  | int | i,
|  | int | j,
|  | int | k,
|  | vtkIdType & | idx
| ) | `[protected]`

void vtkCellLocator::GenerateFace | ( | int | face,
|  | int | numDivs,
|  | int | i,
|  | int | j,
|  | int | k,
|  | vtkPoints * | pts,
|  | vtkCellArray * | polys
| ) | `[protected]`

## Member Data Documentation

int vtkCellLocator::NumberOfCellsPerBucket`[protected]`

| Definition at line 226 of file vtkCellLocator.h.

int vtkCellLocator::NumberOfOctants`[protected]`

| Definition at line 227 of file vtkCellLocator.h.

float vtkCellLocator::Bounds[6]`[protected]`

| Definition at line 228 of file vtkCellLocator.h.

int vtkCellLocator::NumberOfParents`[protected]`

| Definition at line 229 of file vtkCellLocator.h.

float vtkCellLocator::H[3]`[protected]`

| Definition at line 230 of file vtkCellLocator.h.

int vtkCellLocator::NumberOfDivisions`[protected]`

| Definition at line 231 of file vtkCellLocator.h.

vtkIdList** vtkCellLocator::Tree`[protected]`

| Reimplemented in vtkOBBTree. Definition at line 232 of file vtkCellLocator.h.

vtkNeighborCells* vtkCellLocator::Buckets`[protected]`

| Definition at line 241 of file vtkCellLocator.h.

unsigned char* vtkCellLocator::CellHasBeenVisited`[protected]`

| Definition at line 242 of file vtkCellLocator.h.

unsigned char vtkCellLocator::QueryNumber`[protected]`

| Definition at line 243 of file vtkCellLocator.h.

int vtkCellLocator::CacheCellBounds`[protected]`

| Definition at line 244 of file vtkCellLocator.h.

float(* vtkCellLocator::CellBounds)[6]`[protected]`

| Definition at line 246 of file vtkCellLocator.h.

The documentation for this class was generated from the following file:

- Filtering/vtkCellLocator.h